SELECT s1.lastfirst,
  s1.grade_level,
  s1.schoolid,
  s1.state_studentnumber,
  MAX(d1) DTP_1_Date,
  MAX(d2) DTP_2_Date,
  MAX(d3) DTP_3_Date,
  MAX(d4) DTP_4_Date,
  MAX(d5) DTP_5_Date,
  MAX(d6) DTP_6_Date,
  MAX(ha1) HepA_1_Date,
  MAX(ha2) HepA_2_Date,
  MAX(hb1) HepB_1_Date,
  MAX(hb2) HepB_2_Date,
  MAX(hb3) HepB_3_Date,
  MAX(hi1) Hib_1_Date,
  MAX(hi2) Hib_2_Date,
  MAX(hi3) Hib_3_Date,
  MAX(hi4) Hib_4_Date,
  MAX(mm1) MMR_1_Date,
  MAX(mm2) MMR_2_Date,
  MAX(mm3) MMR_3_Date,
  MAX(p1) IPV_1_Date,
  MAX(p2) IPV_2_Date,
  MAX(p3) IPV_3_Date,
  MAX(p4) IPV_4_Date,
  MAX(p5) IPV_5_Date,
  MAX(p6) IPV_6_Date,
  MAX(vc1) Vcp_1_Date,
  MAX(vc2) Vcp_2_Date,
  MAX(d7) Tdap

FROM 
  (SELECT s.lastfirst,
    s.grade_level,
    s.schoolid,
    s.state_studentnumber,
    CASE
      WHEN hv.vaccinename='DTP/DtaP/DT/Td'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END d1,
    CASE
      WHEN hv.vaccinename='DTP/DtaP/DT/Td'
      AND hsdr.dose      =2
      THEN hsdr.dateadministered
    END d2,
    CASE
      WHEN hv.vaccinename='DTP/DtaP/DT/Td'
      AND hsdr.dose      =3
      THEN hsdr.dateadministered
    END d3,
    CASE
      WHEN hv.vaccinename='DTP/DtaP/DT/Td'
      AND hsdr.dose      =4
      THEN hsdr.dateadministered
    END d4,
    CASE
      WHEN hv.vaccinename='DTP/DtaP/DT/Td'
      AND hsdr.dose      =5
      THEN hsdr.dateadministered
    END d5,
    CASE
      WHEN hv.vaccinename='DTP/DtaP/DT/Td'
      AND hsdr.dose      =6
      THEN hsdr.dateadministered
    END d6,
    CASE
      WHEN hv.vaccinename='Hepatitis A'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END ha1,
    CASE
      WHEN hv.vaccinename='Hepatitis A'
      AND hsdr.dose      =2
      THEN hsdr.dateadministered
    END ha2,
     CASE
      WHEN hv.vaccinename='Hepatitis B'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END hb1,
     CASE
      WHEN hv.vaccinename='Hepatitis B'
      AND hsdr.dose      =2
      THEN hsdr.dateadministered
    END hb2,
    CASE
      WHEN hv.vaccinename='Hepatitis B'
      AND hsdr.dose      =3
      THEN hsdr.dateadministered
    END hb3,
    CASE
      WHEN hv.vaccinename='HIB Meningitis'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END hi1,
    CASE
      WHEN hv.vaccinename='HIB Meningitis'
      AND hsdr.dose      =2
      THEN hsdr.dateadministered
    END hi2,
    CASE
      WHEN hv.vaccinename='HIB Meningitis'
      AND hsdr.dose      =3
      THEN hsdr.dateadministered
    END hi3,
    CASE
      WHEN hv.vaccinename='HIB Meningitis'
      AND hsdr.dose      =4
      THEN hsdr.dateadministered
    END hi4,
    CASE
      WHEN hv.vaccinename='MMR'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END mm1,
    CASE
      WHEN hv.vaccinename='MMR'
      AND hsdr.dose      =2
      THEN hsdr.dateadministered
    END mm2,
    CASE
      WHEN hv.vaccinename='MMR'
      AND hsdr.dose      =3
      THEN hsdr.dateadministered
    END mm3,
     CASE
      WHEN hv.vaccinename='Polio'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END p1,
     CASE
      WHEN hv.vaccinename='Polio'
      AND hsdr.dose      =2
      THEN hsdr.dateadministered
    END p2,
    CASE
      WHEN hv.vaccinename='Polio'
      AND hsdr.dose      =3
      THEN hsdr.dateadministered
    END p3,
    CASE
      WHEN hv.vaccinename='Polio'
      AND hsdr.dose      =4
      THEN hsdr.dateadministered
    END p4,
    CASE
      WHEN hv.vaccinename='Polio'
      AND hsdr.dose      =5
      THEN hsdr.dateadministered
    END p5,
    CASE
      WHEN hv.vaccinename='Polio'
      AND hsdr.dose      =6
      THEN hsdr.dateadministered
    END p6,
    CASE
      WHEN hv.vaccinename='Varicella (Chicken pox)'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END vc1,
    CASE
      WHEN hv.vaccinename='Varicella (Chicken pox)'
      AND hsdr.dose      =2
      THEN hsdr.dateadministered
    END vc2,
    CASE
      WHEN hv.vaccinename='Tdap (Pertussis Booster)'
      AND hsdr.dose      =1
      THEN hsdr.dateadministered
    END d7
       
  FROM students s,
    healthstuddoserec hsdr,
    healthstudimmrec hsir,
    healthvaccine hv
  WHERE s.id=hsir.studentid
  AND s.enroll_status = 0
  AND s.grade_level = 8
  AND hv.healthvaccineid=hsir.healthvaccineid
  AND hsir.healthstudimmrecid=hsdr.healthstudimmrecid
  ) s1
GROUP BY s1.lastfirst,
  s1.grade_level,
  s1.schoolid,
  s1.state_studentnumber
ORDER BY s1.schoolid,
  s1.grade_level,
  s1.lastfirst